#include<GL/glut.h>
#include<stdio.h>
#include "glm.h"



GLMmodel* obj;

void changeSize(int w, int h) {

	float ratio;
	// Prevent a divide by zero, when window is too short
	// (you can't make a window of zero width).
	if(h == 0)
		h = 1;

	ratio = 1.0 * w / h;

	// Reset the coordinate system before modifying
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	
	// Set the viewport to be the entire window
    glViewport(0, 0, w, h);

	// Set the correct perspective.
	gluPerspective(45,ratio,1,1000);
	glMatrixMode(GL_MODELVIEW);



}


void renderScene(void) {

	float lpos[4] = {1,1,1,0};
	glClearColor(0.0f,0.0f,0.0f,0.0f);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	glLoadIdentity();
	gluLookAt(0.0,0.0,5.0, 
		      0.0,0.0,-1.0,
			  0.0f,1.0f,0.0f);


	glLightfv(GL_LIGHT0,GL_POSITION,lpos);
// Put Render stuff in here
//	glutWireTeapot(1);

	glmDraw(obj,GLM_SMOOTH|GLM_MATERIAL);

	glutSwapBuffers();
}

void processNormalKeys(unsigned char key, int x, int y) {

	switch(key) {
		case 27: exit(0); break;
	}
}


void main(int argc, char **argv) {
	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_DEPTH | GLUT_DOUBLE | GLUT_RGBA);
	glutInitWindowPosition(100,100);
	glutInitWindowSize(320,320);
	glutCreateWindow("OBJ Demo");
	glutDisplayFunc(renderScene);
	glutIdleFunc(renderScene);
	glutReshapeFunc(changeSize);
	glEnable(GL_DEPTH_TEST);
	glEnable(GL_CULL_FACE);

	glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT0);

	obj = glmReadOBJ("porsche.obj");
	glmUnitize(obj);
	glmFacetNormals(obj);
	glmVertexNormals(obj,90);

	glutMainLoop();
}

